import 'dart:async';

import 'package:flutter/material.dart';
import 'package:wow_views/common/color.dart';
import 'package:wowit/message.dart';

class DemNguocThoigGian extends StatefulWidget {
  const DemNguocThoigGian(
      {Key? key, required this.endTime, required this.hetThoiGian})
      : super(key: key);
  final DateTime? endTime;
  final Function() hetThoiGian;

  @override
  State<DemNguocThoigGian> createState() => _DemNguocThoigGianState();
}

class _DemNguocThoigGianState extends State<DemNguocThoigGian> {
  int timeDiff = 0;
  Timer? timer;

  @override
  void initState() {
    timeDiff = widget.endTime!.difference(DateTime.now()).inSeconds;
    super.initState();
  }
   @override
  void dispose() {
    timer?.cancel();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    int days = timeDiff ~/ (24 * 60 * 60) % 24;
    int hours = timeDiff ~/ (60 * 60) % 24;
    int minutes = (timeDiff ~/ 60) % 60;
    int seconds = timeDiff % 60;

    timer ??= Timer.periodic(const Duration(seconds: 1), (Timer t) {
      handleTick();
    });
    return Row(
      children: [
        if (days > 0) ...[
          lableText(lable: Message.getMessage('SUKIEN_NGAY'), value: days),
        ],
        lableText(lable: Message.getMessage('SUKIEN_GIO'), value: hours),
        lableText(lable: Message.getMessage('SUKIEN_PHUT'), value: minutes),
        lableText(lable: Message.getMessage('SUKIEN_GIAY'), value: seconds),
      ],
    );
    // return Text('$days,$hours,$minutes,$seconds');
  }

  Widget lableText({required String lable, required int value}) {
    return Container(
      margin: const EdgeInsets.symmetric(horizontal: 5),
      padding: const EdgeInsets.all(8),
      decoration: BoxDecoration(
        borderRadius: BorderRadius.circular(5),
        color: Bds8xColor.orange9750,
      ),
      child: Column(
        mainAxisSize: MainAxisSize.min,
        children: <Widget>[
          Text(
            value.toString().padLeft(2, '0'),
            style: const TextStyle(
                color: Colors.white, fontSize: 12, fontWeight: FontWeight.bold),
          ),
          Text(
            lable,
            style: const TextStyle(
              fontSize: 12,
              color: Colors.white70,
            ),
          ),
        ],
      ),
    );
  }

  void handleTick() {
    if (timeDiff > 0) {
      setState(() {
        if (DateTime.now() != widget.endTime) {
          timeDiff = timeDiff - 1;
        } else {
          widget.hetThoiGian();
          timer?.cancel();
        }
      });
    }
  }
}
